def var h1 as handle.
def var h2 as handle.
def var h3 as handle.

procedure logInfo.
   message this-procedure:name target-procedure:name source-procedure:name.
end.

/* super implementation only in h2. */
procedure proc0.
   run logInfo.
   run super.
end.

session:add-super-procedure(this-procedure).

run handle_super_proc_t1.p persist set h1.
run handle_super_proc_t2.p persist set h2.
run handle_super_proc_t3.p persist set h3.

session:add-super-procedure(h3).
this-procedure:add-super-procedure(h1).
h1:add-super-procedure(h2).

/* found in h1 */
do on stop undo, leave:
   run proch1.
end.

/* in in h2, can't be found yet because only direct super-procedures are searched  */
do on stop undo, leave:
   run proch2.
end.

this-procedure:add-super-procedure(h2).
/* in in h2, no can be found */
do on stop undo, leave:
   run proch2.
end.

/* found in h3, from session's super-proc list */
do on stop undo, leave:
   run proch3.
end.

/* this goes in infinite recursion, as 4GL doesn't keep track of processed super-procedures from the session */
run proc0.