def var h1a as handle.
def var h1b as handle.
def var h2 as handle.
def var h3 as handle.
def var r as int.
def var ch as char.

def stream rpt.
output stream rpt to proc_chains.log.

procedure showData.
   export stream rpt ch.
end.

procedure showChain.
   run showChainFirst.
   run showChainLast.
end.

procedure showChainFirst.
   def var hc as handle.
   hc = session:first-procedure.
   ch = "".
   do while hc <> ?:
      ch = ch + string(hc) + "<" + hc:name + ">,".
      hc = hc:next-sibling.
   end.
   run showData.
end.

procedure showChainLast.
   def var hc as handle.
   hc = session:last-procedure.
   ch = "".
   do while hc <> ?:
      ch = ch + string(hc) + "<" + hc:name + ">,".
      hc = hc:prev-sibling.
   end.
   run showData.
end.

run handle_empty_proc1.p persist set h1a.
ch = string(h1a) + "=" + string(session:first-procedure) + " " + h1a:name + "=" + session:first-procedure:name.
run showData.

run handle_empty_proc2.p persist set h2.

ch = string(h2) + "=" + string(session:first-procedure:next-sibling) + " " + h2:name + "=" + session:first-procedure:next-sibling:name.
run showData.

run handle_empty_proc1.p persist set h1b.
ch = string(h1b) + "=" + string(session:first-procedure:next-sibling:next-sibling) + " " + h1b:name + "=" + session:first-procedure:next-sibling:next-sibling:name.
run showData.

ch = string(h1b) + "=" + string(session:last-procedure) + " " +  h1b:name + "=" + session:last-procedure:name.
run showData.

ch = string(h2) + "=" + string(session:last-procedure:prev-sibling) + " " + h2:name + "=" + session:last-procedure:prev-sibling:name.
run showData.

ch = string(h2) + "=" + string(session:last-procedure:prev-sibling:prev-sibling:next-sibling) + " " + h2:name + "=" + session:last-procedure:prev-sibling:prev-sibling:next-sibling:name.
run showData.

ch = string(h1a) + "=" + string(session:last-procedure:prev-sibling:prev-sibling) + " " + h1a:name + "=" + session:last-procedure:prev-sibling:prev-sibling:name.
run showData.

ch = string(h1a) + "=" + string(session:first-procedure:next-sibling:prev-sibling) + " " + h1a:name + "=" + session:first-procedure:next-sibling:prev-sibling:name.
run showData.

ch = string(h1a) + " " + (if h1a:prev-sibling = ? then "?" else string(h1a)) + "=? " + string(h1a:next-sibling) + "=" + string(h2).
run showData.

ch = string(h2) + " " + string(h2:prev-sibling) + "=" + string(h1a) + " " + string(h2:next-sibling) + "=" + string(h1b).
run showData.

ch = "before".
run showData.
run showChain.
run handle_proc_chains2.p.
ch = "after".
run showData.
run showChain.

ch = "deleting " + string(h1b).
run showData.
delete object h1b.
run showChain.

ch = "deleting " + string(h2).
run showData.
delete object h2.
run showChain.

do while session:first-procedure <> ?:
  ch = "deleting " + string(session:first-procedure).
  run showData.
  delete object session:first-procedure.
  run showChain.
end.

output stream rpt close.