/* tests for internal-entries 
- returns all PUBLIC defined functions and internal procedures, in this order:
internal procedures, functions, SUPER procedures (in order of THE DEFINITION, not lexicographic) 
- PRIVATE members are not visible, unless the member belongs to THIS-PROCEDURE
- prototypes (such as IN SUPER or IN handle functions/procs) appear in this list 
- FORWARD functions without implementations do not appear
- IN SUPER procedures are put last.
*/

def var h as handle.

run handle_empty_proc.p persist set h.
message h:name h:internal-entries.

run handle_proc_internal_entries.p persist set h.
message h:name h:internal-entries h:get-signature("f5") h:get-signature("p4").
/* this call will include private members too */
run test in h.