def var h0 as handle.
def var h1 as handle.
def var h2 as handle.
def var h3 as handle.
def var h4a as handle.
def var h4b as handle.

def stream rpt.
output stream rpt to super_basic.log.

procedure showSuperProcs.
   def input param hs as handle.
   export stream rpt hs:super-procedures.
end.

run handle_empty_proc1.p persist set h1.
run handle_empty_proc2.p persist set h2.
run handle_empty_proc3.p persist set h3.
run handle_empty_proc4.p persist set h4a.
run handle_empty_proc4.p persist set h4b.
run handle_empty_proc4.p persist set h0.

export stream rpt string(h1)  h1:name.
export stream rpt string(h2)  h2:name.
export stream rpt string(h3)  h3:name.
export stream rpt string(h4a) h4a:name.
export stream rpt string(h4b) h4b:name.

session:add-super-procedure(h1).
session:add-super-procedure(h2).
session:add-super-procedure(h4a).

run showSuperProcs(session).
session:add-super-procedure(h1).
run showSuperProcs(session).

session:remove-super-procedure(h4a).
run showSuperProcs(session).
session:add-super-procedure(h4a).

h1:add-super-procedure(h1).
h1:add-super-procedure(h4a).
h1:add-super-procedure(h3).
run showSuperProcs(h1).

h1:remove-super-procedure(h4a).
run showSuperProcs(h1).
h1:add-super-procedure(h4a).

delete object h4a.
run showSuperProcs(session).
run showSuperProcs(h1).

output stream rpt close.

h0:add-super-procedure(h0, search-target).
h0:add-super-procedure(h0).
h0:add-super-procedure(h0, search-self).
h0:add-super-procedure(h0).
h0:add-super-procedure(h0, search-target).

h1:add-super-procedure(h1, search-target).
h1:add-super-procedure(h1, search-self).

h2:add-super-procedure(h2, search-self).
h2:add-super-procedure(h2, search-target).

session:add-super-procedure(h4b, search-self).
session:add-super-procedure(h4b, search-target).

session:add-super-procedure(h3, search-target).
session:add-super-procedure(h3, search-self).
