def var h1 as handle.
def var h2 as handle.
def var h3 as handle.
def var j as int.

procedure proch.
   def input parameter i as int.
   message "proch" string(i).
end.

function fh1 returns handle.
   return this-procedure.
end.

function fh2 returns handle(input i as int).
   return this-procedure.
end.

function fh3 returns handle(input h as handle).
   return h.
end.

h1 = session.
run handle_run1a.p persist set h1.

run handle_run1a.p persist set h1.
run handle_run1b.p persist set h2.
run handle_run1c.p persist set h3.

do on error undo, leave:
   run prochidden in h1.
end.

run proch(?).
run proch(0).
run proch in fh1()(0).
run proch in fh2(-1)(0).
run proch in fh3(this-procedure)(0).
run proch in this-procedure(0).
run proch in h1(1).
run proch in h2(2).
run proch in h3(3).

/*
4GL does not allow attributes to be set as the IN handle expression; only
function calls and handles.
run proch in session:last-procedure (30).
run proch in session:first-procedure (10).
run proch in h1:next-sibling (20).
*/

run proch("0").
run proch in fh1()("0").
run proch in fh2(-1)("0").
run proch in fh3(this-procedure)("0").
run proch in this-procedure("0").
run proch in h1("0").
run proch in h2("0").
run proch in h3("0").

do on error undo, leave:
   run proch.
end.
do on error undo, leave:
   run proch in fh1().
end.
do on error undo, leave:
   run proch in fh2(-1).
end.
do on error undo, leave:
   run proch in fh3(this-procedure).
end.
do on error undo, leave:
   run proch in this-procedure.
end.
do on error undo, leave:
   run proch in h1.
end.
do on error undo, leave:
   run proch in h2.
end.
do on error undo, leave:
   run proch in h3.
end.

do on error undo, leave:
   run proch("a").
end.
do on error undo, leave:
   run proch in fh1()("a").
end.
do on error undo, leave:
   run proch in fh2(-1)("a").
end.
do on error undo, leave:
   run proch in fh3(this-procedure)("a").
end.
do on error undo, leave:
   run proch in this-procedure("a").
end.
do on error undo, leave:
   run proch in h1("b").
end.
do on error undo, leave:
   run proch in h2("c").
end.
do on error undo, leave:
   run proch in h3("d").
end.

delete procedure h1.
message valid-handle(h1).
do on error undo, leave:
   run proch in h1.
end.

h1 = ?.
message valid-handle(h1).
do on error undo, leave:
   run proch in h1.
end.

h1 = session.
message valid-handle(h1).
do on error undo, leave:
   run proch in h1.
end.